package com.tax.file.model;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class FinCuspayExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public FinCuspayExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andPayNoIsNull() {
            addCriterion("pay_no is null");
            return (Criteria) this;
        }

        public Criteria andPayNoIsNotNull() {
            addCriterion("pay_no is not null");
            return (Criteria) this;
        }

        public Criteria andPayNoEqualTo(String value) {
            addCriterion("pay_no =", value, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoNotEqualTo(String value) {
            addCriterion("pay_no <>", value, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoGreaterThan(String value) {
            addCriterion("pay_no >", value, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoGreaterThanOrEqualTo(String value) {
            addCriterion("pay_no >=", value, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoLessThan(String value) {
            addCriterion("pay_no <", value, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoLessThanOrEqualTo(String value) {
            addCriterion("pay_no <=", value, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoLike(String value) {
            addCriterion("pay_no like", value, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoNotLike(String value) {
            addCriterion("pay_no not like", value, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoIn(List<String> values) {
            addCriterion("pay_no in", values, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoNotIn(List<String> values) {
            addCriterion("pay_no not in", values, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoBetween(String value1, String value2) {
            addCriterion("pay_no between", value1, value2, "payNo");
            return (Criteria) this;
        }

        public Criteria andPayNoNotBetween(String value1, String value2) {
            addCriterion("pay_no not between", value1, value2, "payNo");
            return (Criteria) this;
        }

        public Criteria andFillDateIsNull() {
            addCriterion("fill_date is null");
            return (Criteria) this;
        }

        public Criteria andFillDateIsNotNull() {
            addCriterion("fill_date is not null");
            return (Criteria) this;
        }

        public Criteria andFillDateEqualTo(Date value) {
            addCriterion("fill_date =", value, "fillDate");
            return (Criteria) this;
        }

        public Criteria andFillDateNotEqualTo(Date value) {
            addCriterion("fill_date <>", value, "fillDate");
            return (Criteria) this;
        }

        public Criteria andFillDateGreaterThan(Date value) {
            addCriterion("fill_date >", value, "fillDate");
            return (Criteria) this;
        }

        public Criteria andFillDateGreaterThanOrEqualTo(Date value) {
            addCriterion("fill_date >=", value, "fillDate");
            return (Criteria) this;
        }

        public Criteria andFillDateLessThan(Date value) {
            addCriterion("fill_date <", value, "fillDate");
            return (Criteria) this;
        }

        public Criteria andFillDateLessThanOrEqualTo(Date value) {
            addCriterion("fill_date <=", value, "fillDate");
            return (Criteria) this;
        }

        public Criteria andFillDateIn(List<Date> values) {
            addCriterion("fill_date in", values, "fillDate");
            return (Criteria) this;
        }

        public Criteria andFillDateNotIn(List<Date> values) {
            addCriterion("fill_date not in", values, "fillDate");
            return (Criteria) this;
        }

        public Criteria andFillDateBetween(Date value1, Date value2) {
            addCriterion("fill_date between", value1, value2, "fillDate");
            return (Criteria) this;
        }

        public Criteria andFillDateNotBetween(Date value1, Date value2) {
            addCriterion("fill_date not between", value1, value2, "fillDate");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameIsNull() {
            addCriterion("pay_unit_one_name is null");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameIsNotNull() {
            addCriterion("pay_unit_one_name is not null");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameEqualTo(String value) {
            addCriterion("pay_unit_one_name =", value, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameNotEqualTo(String value) {
            addCriterion("pay_unit_one_name <>", value, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameGreaterThan(String value) {
            addCriterion("pay_unit_one_name >", value, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameGreaterThanOrEqualTo(String value) {
            addCriterion("pay_unit_one_name >=", value, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameLessThan(String value) {
            addCriterion("pay_unit_one_name <", value, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameLessThanOrEqualTo(String value) {
            addCriterion("pay_unit_one_name <=", value, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameLike(String value) {
            addCriterion("pay_unit_one_name like", value, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameNotLike(String value) {
            addCriterion("pay_unit_one_name not like", value, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameIn(List<String> values) {
            addCriterion("pay_unit_one_name in", values, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameNotIn(List<String> values) {
            addCriterion("pay_unit_one_name not in", values, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameBetween(String value1, String value2) {
            addCriterion("pay_unit_one_name between", value1, value2, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneNameNotBetween(String value1, String value2) {
            addCriterion("pay_unit_one_name not between", value1, value2, "payUnitOneName");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoIsNull() {
            addCriterion("pay_unit_one_taxno is null");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoIsNotNull() {
            addCriterion("pay_unit_one_taxno is not null");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoEqualTo(String value) {
            addCriterion("pay_unit_one_taxno =", value, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoNotEqualTo(String value) {
            addCriterion("pay_unit_one_taxno <>", value, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoGreaterThan(String value) {
            addCriterion("pay_unit_one_taxno >", value, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoGreaterThanOrEqualTo(String value) {
            addCriterion("pay_unit_one_taxno >=", value, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoLessThan(String value) {
            addCriterion("pay_unit_one_taxno <", value, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoLessThanOrEqualTo(String value) {
            addCriterion("pay_unit_one_taxno <=", value, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoLike(String value) {
            addCriterion("pay_unit_one_taxno like", value, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoNotLike(String value) {
            addCriterion("pay_unit_one_taxno not like", value, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoIn(List<String> values) {
            addCriterion("pay_unit_one_taxno in", values, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoNotIn(List<String> values) {
            addCriterion("pay_unit_one_taxno not in", values, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoBetween(String value1, String value2) {
            addCriterion("pay_unit_one_taxno between", value1, value2, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitOneTaxnoNotBetween(String value1, String value2) {
            addCriterion("pay_unit_one_taxno not between", value1, value2, "payUnitOneTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameIsNull() {
            addCriterion("pay_unit_two_name is null");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameIsNotNull() {
            addCriterion("pay_unit_two_name is not null");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameEqualTo(String value) {
            addCriterion("pay_unit_two_name =", value, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameNotEqualTo(String value) {
            addCriterion("pay_unit_two_name <>", value, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameGreaterThan(String value) {
            addCriterion("pay_unit_two_name >", value, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameGreaterThanOrEqualTo(String value) {
            addCriterion("pay_unit_two_name >=", value, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameLessThan(String value) {
            addCriterion("pay_unit_two_name <", value, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameLessThanOrEqualTo(String value) {
            addCriterion("pay_unit_two_name <=", value, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameLike(String value) {
            addCriterion("pay_unit_two_name like", value, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameNotLike(String value) {
            addCriterion("pay_unit_two_name not like", value, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameIn(List<String> values) {
            addCriterion("pay_unit_two_name in", values, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameNotIn(List<String> values) {
            addCriterion("pay_unit_two_name not in", values, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameBetween(String value1, String value2) {
            addCriterion("pay_unit_two_name between", value1, value2, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoNameNotBetween(String value1, String value2) {
            addCriterion("pay_unit_two_name not between", value1, value2, "payUnitTwoName");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoIsNull() {
            addCriterion("pay_unit_two_taxno is null");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoIsNotNull() {
            addCriterion("pay_unit_two_taxno is not null");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoEqualTo(String value) {
            addCriterion("pay_unit_two_taxno =", value, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoNotEqualTo(String value) {
            addCriterion("pay_unit_two_taxno <>", value, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoGreaterThan(String value) {
            addCriterion("pay_unit_two_taxno >", value, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoGreaterThanOrEqualTo(String value) {
            addCriterion("pay_unit_two_taxno >=", value, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoLessThan(String value) {
            addCriterion("pay_unit_two_taxno <", value, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoLessThanOrEqualTo(String value) {
            addCriterion("pay_unit_two_taxno <=", value, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoLike(String value) {
            addCriterion("pay_unit_two_taxno like", value, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoNotLike(String value) {
            addCriterion("pay_unit_two_taxno not like", value, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoIn(List<String> values) {
            addCriterion("pay_unit_two_taxno in", values, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoNotIn(List<String> values) {
            addCriterion("pay_unit_two_taxno not in", values, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoBetween(String value1, String value2) {
            addCriterion("pay_unit_two_taxno between", value1, value2, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andPayUnitTwoTaxnoNotBetween(String value1, String value2) {
            addCriterion("pay_unit_two_taxno not between", value1, value2, "payUnitTwoTaxno");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeIsNull() {
            addCriterion("level1_customs_code is null");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeIsNotNull() {
            addCriterion("level1_customs_code is not null");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeEqualTo(String value) {
            addCriterion("level1_customs_code =", value, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeNotEqualTo(String value) {
            addCriterion("level1_customs_code <>", value, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeGreaterThan(String value) {
            addCriterion("level1_customs_code >", value, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeGreaterThanOrEqualTo(String value) {
            addCriterion("level1_customs_code >=", value, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeLessThan(String value) {
            addCriterion("level1_customs_code <", value, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeLessThanOrEqualTo(String value) {
            addCriterion("level1_customs_code <=", value, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeLike(String value) {
            addCriterion("level1_customs_code like", value, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeNotLike(String value) {
            addCriterion("level1_customs_code not like", value, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeIn(List<String> values) {
            addCriterion("level1_customs_code in", values, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeNotIn(List<String> values) {
            addCriterion("level1_customs_code not in", values, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeBetween(String value1, String value2) {
            addCriterion("level1_customs_code between", value1, value2, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andLevel1CustomsCodeNotBetween(String value1, String value2) {
            addCriterion("level1_customs_code not between", value1, value2, "level1CustomsCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeIsNull() {
            addCriterion("import_port_code is null");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeIsNotNull() {
            addCriterion("import_port_code is not null");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeEqualTo(String value) {
            addCriterion("import_port_code =", value, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeNotEqualTo(String value) {
            addCriterion("import_port_code <>", value, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeGreaterThan(String value) {
            addCriterion("import_port_code >", value, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeGreaterThanOrEqualTo(String value) {
            addCriterion("import_port_code >=", value, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeLessThan(String value) {
            addCriterion("import_port_code <", value, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeLessThanOrEqualTo(String value) {
            addCriterion("import_port_code <=", value, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeLike(String value) {
            addCriterion("import_port_code like", value, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeNotLike(String value) {
            addCriterion("import_port_code not like", value, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeIn(List<String> values) {
            addCriterion("import_port_code in", values, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeNotIn(List<String> values) {
            addCriterion("import_port_code not in", values, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeBetween(String value1, String value2) {
            addCriterion("import_port_code between", value1, value2, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andImportPortCodeNotBetween(String value1, String value2) {
            addCriterion("import_port_code not between", value1, value2, "importPortCode");
            return (Criteria) this;
        }

        public Criteria andTaxAmountIsNull() {
            addCriterion("tax_amount is null");
            return (Criteria) this;
        }

        public Criteria andTaxAmountIsNotNull() {
            addCriterion("tax_amount is not null");
            return (Criteria) this;
        }

        public Criteria andTaxAmountEqualTo(BigDecimal value) {
            addCriterion("tax_amount =", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountNotEqualTo(BigDecimal value) {
            addCriterion("tax_amount <>", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountGreaterThan(BigDecimal value) {
            addCriterion("tax_amount >", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("tax_amount >=", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountLessThan(BigDecimal value) {
            addCriterion("tax_amount <", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("tax_amount <=", value, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountIn(List<BigDecimal> values) {
            addCriterion("tax_amount in", values, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountNotIn(List<BigDecimal> values) {
            addCriterion("tax_amount not in", values, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tax_amount between", value1, value2, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andTaxAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tax_amount not between", value1, value2, "taxAmount");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganIsNull() {
            addCriterion("imcome_organ is null");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganIsNotNull() {
            addCriterion("imcome_organ is not null");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganEqualTo(String value) {
            addCriterion("imcome_organ =", value, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganNotEqualTo(String value) {
            addCriterion("imcome_organ <>", value, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganGreaterThan(String value) {
            addCriterion("imcome_organ >", value, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganGreaterThanOrEqualTo(String value) {
            addCriterion("imcome_organ >=", value, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganLessThan(String value) {
            addCriterion("imcome_organ <", value, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganLessThanOrEqualTo(String value) {
            addCriterion("imcome_organ <=", value, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganLike(String value) {
            addCriterion("imcome_organ like", value, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganNotLike(String value) {
            addCriterion("imcome_organ not like", value, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganIn(List<String> values) {
            addCriterion("imcome_organ in", values, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganNotIn(List<String> values) {
            addCriterion("imcome_organ not in", values, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganBetween(String value1, String value2) {
            addCriterion("imcome_organ between", value1, value2, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andImcomeOrganNotBetween(String value1, String value2) {
            addCriterion("imcome_organ not between", value1, value2, "imcomeOrgan");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoIsNull() {
            addCriterion("submit_file_logo is null");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoIsNotNull() {
            addCriterion("submit_file_logo is not null");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoEqualTo(String value) {
            addCriterion("submit_file_logo =", value, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoNotEqualTo(String value) {
            addCriterion("submit_file_logo <>", value, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoGreaterThan(String value) {
            addCriterion("submit_file_logo >", value, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoGreaterThanOrEqualTo(String value) {
            addCriterion("submit_file_logo >=", value, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoLessThan(String value) {
            addCriterion("submit_file_logo <", value, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoLessThanOrEqualTo(String value) {
            addCriterion("submit_file_logo <=", value, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoLike(String value) {
            addCriterion("submit_file_logo like", value, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoNotLike(String value) {
            addCriterion("submit_file_logo not like", value, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoIn(List<String> values) {
            addCriterion("submit_file_logo in", values, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoNotIn(List<String> values) {
            addCriterion("submit_file_logo not in", values, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoBetween(String value1, String value2) {
            addCriterion("submit_file_logo between", value1, value2, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andSubmitFileLogoNotBetween(String value1, String value2) {
            addCriterion("submit_file_logo not between", value1, value2, "submitFileLogo");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeIsNull() {
            addCriterion("apply_unit_code is null");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeIsNotNull() {
            addCriterion("apply_unit_code is not null");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeEqualTo(String value) {
            addCriterion("apply_unit_code =", value, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeNotEqualTo(String value) {
            addCriterion("apply_unit_code <>", value, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeGreaterThan(String value) {
            addCriterion("apply_unit_code >", value, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeGreaterThanOrEqualTo(String value) {
            addCriterion("apply_unit_code >=", value, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeLessThan(String value) {
            addCriterion("apply_unit_code <", value, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeLessThanOrEqualTo(String value) {
            addCriterion("apply_unit_code <=", value, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeLike(String value) {
            addCriterion("apply_unit_code like", value, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeNotLike(String value) {
            addCriterion("apply_unit_code not like", value, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeIn(List<String> values) {
            addCriterion("apply_unit_code in", values, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeNotIn(List<String> values) {
            addCriterion("apply_unit_code not in", values, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeBetween(String value1, String value2) {
            addCriterion("apply_unit_code between", value1, value2, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andApplyUnitCodeNotBetween(String value1, String value2) {
            addCriterion("apply_unit_code not between", value1, value2, "applyUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeIsNull() {
            addCriterion("customs_unit_code is null");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeIsNotNull() {
            addCriterion("customs_unit_code is not null");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeEqualTo(String value) {
            addCriterion("customs_unit_code =", value, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeNotEqualTo(String value) {
            addCriterion("customs_unit_code <>", value, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeGreaterThan(String value) {
            addCriterion("customs_unit_code >", value, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeGreaterThanOrEqualTo(String value) {
            addCriterion("customs_unit_code >=", value, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeLessThan(String value) {
            addCriterion("customs_unit_code <", value, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeLessThanOrEqualTo(String value) {
            addCriterion("customs_unit_code <=", value, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeLike(String value) {
            addCriterion("customs_unit_code like", value, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeNotLike(String value) {
            addCriterion("customs_unit_code not like", value, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeIn(List<String> values) {
            addCriterion("customs_unit_code in", values, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeNotIn(List<String> values) {
            addCriterion("customs_unit_code not in", values, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeBetween(String value1, String value2) {
            addCriterion("customs_unit_code between", value1, value2, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andCustomsUnitCodeNotBetween(String value1, String value2) {
            addCriterion("customs_unit_code not between", value1, value2, "customsUnitCode");
            return (Criteria) this;
        }

        public Criteria andTradeWayIsNull() {
            addCriterion("trade_way is null");
            return (Criteria) this;
        }

        public Criteria andTradeWayIsNotNull() {
            addCriterion("trade_way is not null");
            return (Criteria) this;
        }

        public Criteria andTradeWayEqualTo(String value) {
            addCriterion("trade_way =", value, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayNotEqualTo(String value) {
            addCriterion("trade_way <>", value, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayGreaterThan(String value) {
            addCriterion("trade_way >", value, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayGreaterThanOrEqualTo(String value) {
            addCriterion("trade_way >=", value, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayLessThan(String value) {
            addCriterion("trade_way <", value, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayLessThanOrEqualTo(String value) {
            addCriterion("trade_way <=", value, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayLike(String value) {
            addCriterion("trade_way like", value, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayNotLike(String value) {
            addCriterion("trade_way not like", value, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayIn(List<String> values) {
            addCriterion("trade_way in", values, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayNotIn(List<String> values) {
            addCriterion("trade_way not in", values, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayBetween(String value1, String value2) {
            addCriterion("trade_way between", value1, value2, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andTradeWayNotBetween(String value1, String value2) {
            addCriterion("trade_way not between", value1, value2, "tradeWay");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeIsNull() {
            addCriterion("budget_subjects_code is null");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeIsNotNull() {
            addCriterion("budget_subjects_code is not null");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeEqualTo(String value) {
            addCriterion("budget_subjects_code =", value, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeNotEqualTo(String value) {
            addCriterion("budget_subjects_code <>", value, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeGreaterThan(String value) {
            addCriterion("budget_subjects_code >", value, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeGreaterThanOrEqualTo(String value) {
            addCriterion("budget_subjects_code >=", value, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeLessThan(String value) {
            addCriterion("budget_subjects_code <", value, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeLessThanOrEqualTo(String value) {
            addCriterion("budget_subjects_code <=", value, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeLike(String value) {
            addCriterion("budget_subjects_code like", value, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeNotLike(String value) {
            addCriterion("budget_subjects_code not like", value, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeIn(List<String> values) {
            addCriterion("budget_subjects_code in", values, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeNotIn(List<String> values) {
            addCriterion("budget_subjects_code not in", values, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeBetween(String value1, String value2) {
            addCriterion("budget_subjects_code between", value1, value2, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andBudgetSubjectsCodeNotBetween(String value1, String value2) {
            addCriterion("budget_subjects_code not between", value1, value2, "budgetSubjectsCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeIsNull() {
            addCriterion("collection_treasury_code is null");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeIsNotNull() {
            addCriterion("collection_treasury_code is not null");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeEqualTo(String value) {
            addCriterion("collection_treasury_code =", value, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeNotEqualTo(String value) {
            addCriterion("collection_treasury_code <>", value, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeGreaterThan(String value) {
            addCriterion("collection_treasury_code >", value, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeGreaterThanOrEqualTo(String value) {
            addCriterion("collection_treasury_code >=", value, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeLessThan(String value) {
            addCriterion("collection_treasury_code <", value, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeLessThanOrEqualTo(String value) {
            addCriterion("collection_treasury_code <=", value, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeLike(String value) {
            addCriterion("collection_treasury_code like", value, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeNotLike(String value) {
            addCriterion("collection_treasury_code not like", value, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeIn(List<String> values) {
            addCriterion("collection_treasury_code in", values, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeNotIn(List<String> values) {
            addCriterion("collection_treasury_code not in", values, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeBetween(String value1, String value2) {
            addCriterion("collection_treasury_code between", value1, value2, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andCollectionTreasuryCodeNotBetween(String value1, String value2) {
            addCriterion("collection_treasury_code not between", value1, value2, "collectionTreasuryCode");
            return (Criteria) this;
        }

        public Criteria andContractNoIsNull() {
            addCriterion("contract_no is null");
            return (Criteria) this;
        }

        public Criteria andContractNoIsNotNull() {
            addCriterion("contract_no is not null");
            return (Criteria) this;
        }

        public Criteria andContractNoEqualTo(String value) {
            addCriterion("contract_no =", value, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoNotEqualTo(String value) {
            addCriterion("contract_no <>", value, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoGreaterThan(String value) {
            addCriterion("contract_no >", value, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoGreaterThanOrEqualTo(String value) {
            addCriterion("contract_no >=", value, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoLessThan(String value) {
            addCriterion("contract_no <", value, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoLessThanOrEqualTo(String value) {
            addCriterion("contract_no <=", value, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoLike(String value) {
            addCriterion("contract_no like", value, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoNotLike(String value) {
            addCriterion("contract_no not like", value, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoIn(List<String> values) {
            addCriterion("contract_no in", values, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoNotIn(List<String> values) {
            addCriterion("contract_no not in", values, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoBetween(String value1, String value2) {
            addCriterion("contract_no between", value1, value2, "contractNo");
            return (Criteria) this;
        }

        public Criteria andContractNoNotBetween(String value1, String value2) {
            addCriterion("contract_no not between", value1, value2, "contractNo");
            return (Criteria) this;
        }

        public Criteria andTransportIsNull() {
            addCriterion("transport is null");
            return (Criteria) this;
        }

        public Criteria andTransportIsNotNull() {
            addCriterion("transport is not null");
            return (Criteria) this;
        }

        public Criteria andTransportEqualTo(String value) {
            addCriterion("transport =", value, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportNotEqualTo(String value) {
            addCriterion("transport <>", value, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportGreaterThan(String value) {
            addCriterion("transport >", value, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportGreaterThanOrEqualTo(String value) {
            addCriterion("transport >=", value, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportLessThan(String value) {
            addCriterion("transport <", value, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportLessThanOrEqualTo(String value) {
            addCriterion("transport <=", value, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportLike(String value) {
            addCriterion("transport like", value, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportNotLike(String value) {
            addCriterion("transport not like", value, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportIn(List<String> values) {
            addCriterion("transport in", values, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportNotIn(List<String> values) {
            addCriterion("transport not in", values, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportBetween(String value1, String value2) {
            addCriterion("transport between", value1, value2, "transport");
            return (Criteria) this;
        }

        public Criteria andTransportNotBetween(String value1, String value2) {
            addCriterion("transport not between", value1, value2, "transport");
            return (Criteria) this;
        }

        public Criteria andPaymentTermIsNull() {
            addCriterion("payment_term is null");
            return (Criteria) this;
        }

        public Criteria andPaymentTermIsNotNull() {
            addCriterion("payment_term is not null");
            return (Criteria) this;
        }

        public Criteria andPaymentTermEqualTo(Date value) {
            addCriterion("payment_term =", value, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andPaymentTermNotEqualTo(Date value) {
            addCriterion("payment_term <>", value, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andPaymentTermGreaterThan(Date value) {
            addCriterion("payment_term >", value, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andPaymentTermGreaterThanOrEqualTo(Date value) {
            addCriterion("payment_term >=", value, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andPaymentTermLessThan(Date value) {
            addCriterion("payment_term <", value, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andPaymentTermLessThanOrEqualTo(Date value) {
            addCriterion("payment_term <=", value, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andPaymentTermIn(List<Date> values) {
            addCriterion("payment_term in", values, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andPaymentTermNotIn(List<Date> values) {
            addCriterion("payment_term not in", values, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andPaymentTermBetween(Date value1, Date value2) {
            addCriterion("payment_term between", value1, value2, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andPaymentTermNotBetween(Date value1, Date value2) {
            addCriterion("payment_term not between", value1, value2, "paymentTerm");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoIsNull() {
            addCriterion("delivery_no is null");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoIsNotNull() {
            addCriterion("delivery_no is not null");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoEqualTo(String value) {
            addCriterion("delivery_no =", value, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoNotEqualTo(String value) {
            addCriterion("delivery_no <>", value, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoGreaterThan(String value) {
            addCriterion("delivery_no >", value, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoGreaterThanOrEqualTo(String value) {
            addCriterion("delivery_no >=", value, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoLessThan(String value) {
            addCriterion("delivery_no <", value, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoLessThanOrEqualTo(String value) {
            addCriterion("delivery_no <=", value, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoLike(String value) {
            addCriterion("delivery_no like", value, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoNotLike(String value) {
            addCriterion("delivery_no not like", value, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoIn(List<String> values) {
            addCriterion("delivery_no in", values, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoNotIn(List<String> values) {
            addCriterion("delivery_no not in", values, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoBetween(String value1, String value2) {
            addCriterion("delivery_no between", value1, value2, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andDeliveryNoNotBetween(String value1, String value2) {
            addCriterion("delivery_no not between", value1, value2, "deliveryNo");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateDateIsNull() {
            addCriterion("create_date is null");
            return (Criteria) this;
        }

        public Criteria andCreateDateIsNotNull() {
            addCriterion("create_date is not null");
            return (Criteria) this;
        }

        public Criteria andCreateDateEqualTo(Date value) {
            addCriterion("create_date =", value, "createDate");
            return (Criteria) this;
        }

        public Criteria andCreateDateNotEqualTo(Date value) {
            addCriterion("create_date <>", value, "createDate");
            return (Criteria) this;
        }

        public Criteria andCreateDateGreaterThan(Date value) {
            addCriterion("create_date >", value, "createDate");
            return (Criteria) this;
        }

        public Criteria andCreateDateGreaterThanOrEqualTo(Date value) {
            addCriterion("create_date >=", value, "createDate");
            return (Criteria) this;
        }

        public Criteria andCreateDateLessThan(Date value) {
            addCriterion("create_date <", value, "createDate");
            return (Criteria) this;
        }

        public Criteria andCreateDateLessThanOrEqualTo(Date value) {
            addCriterion("create_date <=", value, "createDate");
            return (Criteria) this;
        }

        public Criteria andCreateDateIn(List<Date> values) {
            addCriterion("create_date in", values, "createDate");
            return (Criteria) this;
        }

        public Criteria andCreateDateNotIn(List<Date> values) {
            addCriterion("create_date not in", values, "createDate");
            return (Criteria) this;
        }

        public Criteria andCreateDateBetween(Date value1, Date value2) {
            addCriterion("create_date between", value1, value2, "createDate");
            return (Criteria) this;
        }

        public Criteria andCreateDateNotBetween(Date value1, Date value2) {
            addCriterion("create_date not between", value1, value2, "createDate");
            return (Criteria) this;
        }

        public Criteria andTkFileIdIsNull() {
            addCriterion("tk_file_id is null");
            return (Criteria) this;
        }

        public Criteria andTkFileIdIsNotNull() {
            addCriterion("tk_file_id is not null");
            return (Criteria) this;
        }

        public Criteria andTkFileIdEqualTo(Integer value) {
            addCriterion("tk_file_id =", value, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andTkFileIdNotEqualTo(Integer value) {
            addCriterion("tk_file_id <>", value, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andTkFileIdGreaterThan(Integer value) {
            addCriterion("tk_file_id >", value, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andTkFileIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("tk_file_id >=", value, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andTkFileIdLessThan(Integer value) {
            addCriterion("tk_file_id <", value, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andTkFileIdLessThanOrEqualTo(Integer value) {
            addCriterion("tk_file_id <=", value, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andTkFileIdIn(List<Integer> values) {
            addCriterion("tk_file_id in", values, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andTkFileIdNotIn(List<Integer> values) {
            addCriterion("tk_file_id not in", values, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andTkFileIdBetween(Integer value1, Integer value2) {
            addCriterion("tk_file_id between", value1, value2, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andTkFileIdNotBetween(Integer value1, Integer value2) {
            addCriterion("tk_file_id not between", value1, value2, "tkFileId");
            return (Criteria) this;
        }

        public Criteria andDelFlagIsNull() {
            addCriterion("del_flag is null");
            return (Criteria) this;
        }

        public Criteria andDelFlagIsNotNull() {
            addCriterion("del_flag is not null");
            return (Criteria) this;
        }

        public Criteria andDelFlagEqualTo(String value) {
            addCriterion("del_flag =", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotEqualTo(String value) {
            addCriterion("del_flag <>", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagGreaterThan(String value) {
            addCriterion("del_flag >", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagGreaterThanOrEqualTo(String value) {
            addCriterion("del_flag >=", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagLessThan(String value) {
            addCriterion("del_flag <", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagLessThanOrEqualTo(String value) {
            addCriterion("del_flag <=", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagLike(String value) {
            addCriterion("del_flag like", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotLike(String value) {
            addCriterion("del_flag not like", value, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagIn(List<String> values) {
            addCriterion("del_flag in", values, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotIn(List<String> values) {
            addCriterion("del_flag not in", values, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagBetween(String value1, String value2) {
            addCriterion("del_flag between", value1, value2, "delFlag");
            return (Criteria) this;
        }

        public Criteria andDelFlagNotBetween(String value1, String value2) {
            addCriterion("del_flag not between", value1, value2, "delFlag");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateDateIsNull() {
            addCriterion("update_date is null");
            return (Criteria) this;
        }

        public Criteria andUpdateDateIsNotNull() {
            addCriterion("update_date is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateDateEqualTo(Date value) {
            addCriterion("update_date =", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateNotEqualTo(Date value) {
            addCriterion("update_date <>", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateGreaterThan(Date value) {
            addCriterion("update_date >", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateGreaterThanOrEqualTo(Date value) {
            addCriterion("update_date >=", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateLessThan(Date value) {
            addCriterion("update_date <", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateLessThanOrEqualTo(Date value) {
            addCriterion("update_date <=", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateIn(List<Date> values) {
            addCriterion("update_date in", values, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateNotIn(List<Date> values) {
            addCriterion("update_date not in", values, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateBetween(Date value1, Date value2) {
            addCriterion("update_date between", value1, value2, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateNotBetween(Date value1, Date value2) {
            addCriterion("update_date not between", value1, value2, "updateDate");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}